/*                                          
  Small Game Library
  v 0.0
*/ 
#include "sgl.h"
// INTERNAL
//====================================================================================================

Uint32 ticks;
SDL_Surface *SGLscreen;
Mix_Music *music;
char *_fontPath;

// fileExist(filename)			: see if a file exists
int fileExists( char *name )
{
    FILE    *handle;
    /* try to open the file */
    handle = fopen( name, "rb" );
    if (handle == NULL) return 0;
    fclose( handle );
    return -1;
}

char *let(char *string){
     char *buffer;
     int l;
     l=strlen(string);
     buffer =(char *) malloc(l);
     strcpy(buffer,string);
     return string;
}
//====================================================================================================


int joy[20];//public key

// START && SURFACE
//====================================================================================================

surface *sgl_start(){
    SGLscreen = NULL;
            
	/* Initialize SDL */
	if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0) {
		fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
		exit (1);
	}
	atexit (sgl_terminate);
	
    Mix_OpenAudio(44100, AUDIO_U8,	2, 8192);
    TTF_Init();
    
    SDL_ShowCursor(SDL_DISABLE);

	/* Set 320x240 16-bits video mode */
	SGLscreen = SDL_SetVideoMode (320, 240, 16, SDL_SWSURFACE);
	if (SGLscreen == NULL) {
		fprintf (stderr, "Couldn't set 320x240x16 video mode: %s\n", SDL_GetError ());
		exit (2);
	}
	
    SDL_Joystick *joy = NULL;
	/* Check and open joystick device */
	if (SDL_NumJoysticks() > 0) {
		joy = SDL_JoystickOpen(0);
		if(!joy) {
			fprintf (stderr, "Couldn't open joystick 0: %s\n", SDL_GetError ());
		}
	}	
	return SGLscreen;
}
//____________________________________________________________________________________________________

void sgl_terminate(){
	SDL_Quit();
#ifdef GP2X
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
#endif
}
//____________________________________________________________________________________________________

//simulate the page swapping and update the events
void screenswap(){
     SDL_Event event;
     int i;
     
	while(ticks>SDL_GetTicks()){
     while (SDL_PollEvent (&event)){
           switch (event.type){
                  
                case SDL_KEYDOWN:
					/* if press Ctrl + C, terminate program */
					if ( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)) )exit(2);
					   
					//emulations ok joy keys and joy arrows
					if ( event.key.keysym.sym == SDLK_UP )joy[VK_UP]=1;//VK_UP 
					if ( event.key.keysym.sym == SDLK_LEFT )joy[VK_LEFT]=1;//VK_LEFT
					if ( event.key.keysym.sym == SDLK_DOWN )joy[VK_DOWN]=1;//VK_DOWN
					if ( event.key.keysym.sym == SDLK_RIGHT )joy[VK_RIGHT]=1;//VK_RIGHT
                 	if (joy[VK_UP] && joy[VK_LEFT])joy[VK_UP_LEFT]=1;//VK_UP_LEFT
                 	if (joy[VK_DOWN] && joy[VK_LEFT])joy[VK_DOWN_LEFT]=1;//VK_DOWN_LEFT
                 	if (joy[VK_DOWN] && joy[VK_RIGHT])joy[VK_DOWN_RIGHT]=1;//VK_DOWN_RIGHT 
                 	if (joy[VK_UP] && joy[VK_RIGHT])joy[VK_UP_RIGHT]=1;//VK_UP_RIGHT
                          
					if ( event.key.keysym.sym == SDLK_RETURN )joy[VK_START]=1;//VK_START
                    if ( event.key.keysym.sym == SDLK_SPACE )joy[VK_SELECT]=1;//VK_SELECT                         
	                if ( event.key.keysym.sym == SDLK_LSHIFT )joy[VK_FL]=1;//VK_FL 
                    if ( event.key.keysym.sym == SDLK_RSHIFT )joy[VK_FR]=1;//VK_FR         
                    if ( event.key.keysym.sym == SDLK_a )joy[VK_FA]=1;//VK_FA         
                    if ( event.key.keysym.sym == SDLK_s )joy[VK_FB]=1;//VK_FB         
                    if ( event.key.keysym.sym == SDLK_d )joy[VK_FX]=1;//VK_FX         
                    if ( event.key.keysym.sym == SDLK_f )joy[VK_FY]=1;//VK_FY         
                    if ( event.key.keysym.sym == SDLK_PAGEUP )joy[VK_VOL_UP]=1;//VK_VOL_UP     
	                if ( event.key.keysym.sym == SDLK_PAGEDOWN )joy[VK_VOL_DOWN]=1;//VK_VOL_DOWN   
                    if ( event.key.keysym.sym == SDLK_RCTRL )joy[VK_TAT]=1;//VK_TAT        
					break;
										
				case SDL_KEYUP:
					//emulations ok joy keys and joy arrows
					if ( event.key.keysym.sym == SDLK_UP )joy[VK_UP]=0;//VK_UP
					if ( event.key.keysym.sym == SDLK_LEFT )joy[VK_LEFT]=0;//VK_LEFT
					if ( event.key.keysym.sym == SDLK_DOWN )joy[VK_DOWN]=0;//VK_DOWN
					if ( event.key.keysym.sym == SDLK_RIGHT )joy[VK_RIGHT]=0;//VK_RIGHT
                 	if (!joy[VK_UP] || !joy[VK_LEFT])joy[VK_UP_LEFT]=0;//VK_UP_LEFT
                 	if (!joy[VK_DOWN] || !joy[VK_LEFT])joy[VK_DOWN_LEFT]=0;//VK_DOWN_LEFT
                 	if (!joy[VK_DOWN] || !joy[VK_RIGHT])joy[VK_DOWN_RIGHT]=0;//VK_DOWN_RIGHT 
                 	if (!joy[VK_UP] || !joy[VK_RIGHT])joy[VK_UP_RIGHT]=0;//VK_UP_RIGHT
 					
					if ( event.key.keysym.sym == SDLK_RETURN )joy[VK_START]=0;//VK_START   
                    if ( event.key.keysym.sym == SDLK_SPACE )joy[VK_SELECT]=0;//VK_SELECT  
	                if ( event.key.keysym.sym == SDLK_LSHIFT )joy[VK_FL]=0;//VK_FL 
                    if ( event.key.keysym.sym == SDLK_RSHIFT )joy[VK_FR]=0;//VK_FR         
                    if ( event.key.keysym.sym == SDLK_a )joy[VK_FA]=0;//VK_FA         
                    if ( event.key.keysym.sym == SDLK_s )joy[VK_FB]=0;//VK_FB         
                    if ( event.key.keysym.sym == SDLK_d )joy[VK_FX]=0;//VK_FX         
                    if ( event.key.keysym.sym == SDLK_f )joy[VK_FY]=0;//VK_FY         
                    if ( event.key.keysym.sym == SDLK_PAGEUP )joy[VK_VOL_UP]=0;//VK_VOL_UP     
	                if ( event.key.keysym.sym == SDLK_PAGEDOWN )joy[VK_VOL_DOWN]=0;//VK_VOL_DOWN   
                    if ( event.key.keysym.sym == SDLK_RCTRL )joy[VK_TAT]=0;//VK_TAT        
 					break;
 					
				case SDL_JOYBUTTONDOWN:
                    for (i=0;i<19;i++){ 
   					    if ( event.jbutton.button == i )
   					       joy[i]=1;
                    }                        
					break;
					
				case SDL_JOYBUTTONUP:
                   for (i=0;i<19;i++){ 
   					    if ( event.jbutton.button == i )
   					       joy[i]=0;
                    }                        
					break;
					
				case SDL_QUIT:
					exit(2);
					break;
					
				default:
					break;
					
			}
      }
   }      
   SDL_Flip(SGLscreen);
   ticks=SDL_GetTicks()+2;
}
//____________________________________________________________________________________________________

SDL_Surface *surface_create(int w, int h, int trasparency){
      SDL_Surface *surface;
      surface= SDL_CreateRGBSurface(SDL_SWSURFACE, w, h,(SGLscreen->format->BytesPerPixel * 8),0,0,0,0);      
      if(trasparency)
           SDL_SetColorKey(surface, (SDL_SRCCOLORKEY|SDL_RLEACCEL),0);
      return surface;                
}
//____________________________________________________________________________________________________

SDL_Surface *surface_load(char *filename,int trasparency){
	SDL_Surface *surface=NULL;

    if( fileExists(filename)){
    	surface =SDL_DisplayFormat(IMG_Load(filename));
        if(trasparency){
               SDL_SetColorKey(surface, (SDL_SRCCOLORKEY|SDL_RLEACCEL),0);
        }
    }                
    return surface;
}
//____________________________________________________________________________________________________

void surface_destroy(SDL_Surface *surface){
     if (surface!=NULL)
        SDL_FreeSurface(surface);
}
//____________________________________________________________________________________________________

void paste( SDL_Surface *dst, int x, int y, SDL_Surface *src){
	SDL_Rect d;
    if (dst!=NULL &&src!=NULL){
		d.x=x;
		d.y=y;
        d.w=src->w;
        d.h=src->h;
        SDL_BlitSurface(src, NULL, dst, &d );
    }
}
//____________________________________________________________________________________________________
void blt( SDL_Surface *dst, int x, int y, SDL_Surface *src, int xs, int ys, int w, int h){
	SDL_Rect s;
	SDL_Rect d;
	
    if (dst!=NULL &&src!=NULL){
		s.x=xs;
		s.y=ys;
        s.w=w;
        s.h=h;
	
		d.x=x;
		d.y=y;
        d.w=w;
        d.h=h;

        SDL_BlitSurface(src, &s, dst, &d );
    }
}
//____________________________________________________________________________________________________

// GRAPHICS PRIMITIVES
//====================================================================================================

Uint32 rgb( int r, int g, int b){
       // FFFF:FFFFFF=x:rgb       
       //x = rgb * FFFF/FFFFFF
       //       
       return ((b/8) +((g / 8)*64)+((r /8)*64*32));
       
       
}
//____________________________________________________________________________________________________

void cls( SDL_Surface *dst,Uint32 color){
         SDL_FillRect (dst, NULL, color);
     }
//____________________________________________________________________________________________________

void plot( SDL_Surface *surface, int x, int y, Uint32 col ){
    Uint8 *p;
	if (x>=0 && y>=0 && x<surface->w && y<surface->h){
		p=(Uint8 *)surface->pixels + (y * surface->pitch) + x * 2;
		*(Uint16 *)p=col;
	}
}

//____________________________________________________________________________________________________

Uint32 point( SDL_Surface *surface, int x, int y){
    Uint8 *p;
    if (x>=0 && y>=0 && x<surface->w && y<surface->h){
	   p=(Uint8 *)surface->pixels + y * surface->pitch + x * 2;
   	   return *(Uint16 *)p;
    }
    else{
	    return 0;
    }
}
//____________________________________________________________________________________________________

void hline( SDL_Surface * surface, int x1, int y1, int w, Uint32 color){
     int x;
     for(x=0;x<w;x++)plot( surface,x1+x,y1,color);
}
//____________________________________________________________________________________________________

void vline( SDL_Surface * surface, int x1, int y1, int h, Uint32 color){
     int y;
     for(y=0;y<h;y++)plot( surface,x1,y1+y,color);
}
//____________________________________________________________________________________________________
/*  Draw a line to use with other function like rect) */
void line( SDL_Surface * surface, int x1, int y1, int x2, int y2, Uint32 color){
    //  Draw a line WITHOUT REFRESH VIDEO (to use with other function like rect)
    static int c,x,y;
    double slope;

    int dx = x2 - x1;  /* change in x */
    int dy = y2 - y1;  /* change in y */

    slope = (double)dy / dx;

    if (abs(dx) >= abs(dy)) {
        /* draw left/right - right/left */
        c = (x1 <= x2) ? 1 : -1;
        for (x = x1; x != x2 + c; x += c) {
            y = y1 + (int)( (x - x1) * slope + 0.5 );
            plot(surface, x, y, color);
        }
    }
    else
    {
        /* draw top/bottom - bottom/top */
        c = (y1 <= y2) ? 1 : -1;
        for (y = y1; y != y2 + c; y += c) {
            x = x1 + (int)( (y - y1) / slope + 0.5 );
            plot(surface, x, y, color);
        }
    }
}
//________________________________________________________________________________________________________________________________________

/* draw empty rect */
void box( SDL_Surface *surface, int x, int y, int w, int h, Uint32 color){
     int i;
     for(i=0;i<=w;i++){plot(surface,x+i,y,color);plot(surface,x+i,y+h,color);}
     for(i=0;i<=h;i++){plot(surface,x,y+i,color);plot(surface,x+w,y+i,color);}
}
//________________________________________________________________________________________________________________________________________

void bar( SDL_Surface *dst, int x, int y, int w, int h, Uint32 color){
     SDL_Rect d;

	d.x=x;
	d.y=y;
	d.w=w;
	d.h=h;
    SDL_FillRect (dst, &d, color);
}
//____________________________________________________________________________________________________

/*draw empty circle */
void circle( SDL_Surface *surface, int vx, int vy, int r, Uint32 color){

  Sint16 x = 0;
  Sint16 y = r-1;     /*radius zero == draw nothing*/
  Sint16 d = 3 - 2*r;
  Sint16 diagonalInc = 10 - 4*r;
  Sint16 rightInc = 6;

  while (x <= y) {

    plot(surface,vx+x,vy+y,color);
    plot(surface,vx+x,vy-y,color);
    plot(surface,vx-x,vy+y,color);
    plot(surface,vx-x,vy-y,color);

    plot(surface,vx+y,vy+x,color);
    plot(surface,vx+y,vy-x,color);
    plot(surface,vx-y,vy+x,color);
    plot(surface,vx-y,vy-x,color);


  if (d >=  0) {
      d += diagonalInc;
      diagonalInc += 8;
      y -= 1;
    } else {
      d += rightInc;
      diagonalInc += 4;
    }
    rightInc += 4;
    x += 1;
  }
}
//________________________________________________________________________________________________________________________________________

/* draw fill circle */
void fillcircle( SDL_Surface *surface, int vx, int vy, int r, Uint32 color){

  Sint16 x = 0;
  Sint16 y = r-1;     /*radius zero == draw nothing*/
  Sint16 d = 3 - 2*r;
  Sint16 diagonalInc = 10 - 4*r;
  Sint16 rightInc = 6;

  while (x <= y) {

    hline(surface,vx-x,vy+y,x+x,color);
    hline(surface,vx-x,vy-y,x+x,color);
    hline(surface,vx-y,vy+x,y+y,color);
    hline(surface,vx-y,vy-x,y+y,color);

  if (d >=  0) {
      d += diagonalInc;
      diagonalInc += 8;
      y -= 1;
    } else {
      d += rightInc;
      diagonalInc += 4;
    }
    rightInc += 4;
    x += 1;
  }
}
//________________________________________________________________________________________________________________________________________

/* draw empty ellipse */
void ellipse( SDL_Surface *surface, int vx, int vy, int Xradius, int Yradius, Uint32 color){
  Sint32 x, y;
  Sint32 Xchange, Ychange;
  Sint32 EllipseError;
  Sint32 TwoASquare, TwoBSquare;
  Sint32 StoppingX, StoppingY;

  TwoASquare = 2*Xradius*Xradius;
  TwoBSquare = 2*Yradius*Yradius;

  /*1st set of points*/
  x = Xradius-1;  /*radius zero == draw nothing*/
  y = 0;

  Xchange = Yradius*Yradius*(1-2*Xradius);
  Ychange = Xradius*Xradius;

  EllipseError = 0;

  StoppingX = TwoBSquare*Xradius;
  StoppingY = 0;

  /*Plot four ellipse points by iteration*/
  while (StoppingX > StoppingY) {

    plot(surface,vx+x,vy+y,color);
    plot(surface,vx+x,vy-y,color);
    plot(surface,vx-x,vy+y,color);
    plot(surface,vx-x,vy-y,color);


    ++y;
    StoppingY    += TwoASquare;
    EllipseError += Ychange;
    Ychange      += TwoASquare;
    if (( 2*EllipseError + Xchange) > 0) {
      --x;
      StoppingX    -= TwoBSquare;
      EllipseError += Xchange;
      Xchange      += TwoBSquare;
    }
  }/*while*/

  /*2nd set of points*/
  x = 0;
  y = Yradius-1;  /*radius zero == draw nothing*/
  Xchange = Yradius*Yradius;
  Ychange = Xradius*Xradius*(1-2*Yradius);
  EllipseError = 0;
  StoppingX = 0;
  StoppingY = TwoASquare*Yradius;

  /*Plot four ellipse points by iteration*/
  while (StoppingX < StoppingY) {

    plot(surface,vx+x,vy+y,color);
    plot(surface,vx+x,vy-y,color);
    plot(surface,vx-x,vy+y,color);
    plot(surface,vx-x,vy-y,color);

    ++x;
    StoppingX    += TwoBSquare;
    EllipseError += Xchange;
    Xchange      += TwoBSquare;
    if ((2*EllipseError + Ychange) > 0) {
      --y;
      StoppingY    -= TwoASquare;
      EllipseError += Ychange;
      Ychange      += TwoASquare;
    }
  }
}
//________________________________________________________________________________________________________________________________________

/* draw fill ellipse */
void fillellipse( SDL_Surface *surface, int vx, int vy, int Xradius, int Yradius, Uint32 color){
  Sint32 x, y;
  Sint32 Xchange, Ychange;
  Sint32 EllipseError;
  Sint32 TwoASquare, TwoBSquare;
  Sint32 StoppingX, StoppingY;

  TwoASquare = 2*Xradius*Xradius;
  TwoBSquare = 2*Yradius*Yradius;

  /*1st set of points*/
  x = Xradius-1;  /*radius zero == draw nothing*/
  y = 0;

  Xchange = Yradius*Yradius*(1-2*Xradius);
  Ychange = Xradius*Xradius;

  EllipseError = 0;

  StoppingX = TwoBSquare*Xradius;
  StoppingY = 0;

  /*Plot four ellipse points by iteration*/
  while (StoppingX > StoppingY) {

    hline(surface,vx-x,vy+y,x*2,color);
    hline(surface,vx-x,vy-y,x*2,color);


    ++y;
    StoppingY    += TwoASquare;
    EllipseError += Ychange;
    Ychange      += TwoASquare;
    if (( 2*EllipseError + Xchange) > 0) {
      --x;
      StoppingX    -= TwoBSquare;
      EllipseError += Xchange;
      Xchange      += TwoBSquare;
    }
  }/*while*/

  /*2nd set of points*/
  x = 0;
  y = Yradius-1;  /*radius zero == draw nothing*/
  Xchange = Yradius*Yradius;
  Ychange = Xradius*Xradius*(1-2*Yradius);
  EllipseError = 0;
  StoppingX = 0;
  StoppingY = TwoASquare*Yradius;

  /*Plot four ellipse points by iteration*/
  while (StoppingX < StoppingY) {

    hline(surface,vx-x,vy+y,x*2,color);
    hline(surface,vx-x,vy-y,x*2,color);

    ++x;
    StoppingX    += TwoBSquare;
    EllipseError += Xchange;
    Xchange      += TwoBSquare;
    if ((2*EllipseError + Ychange) > 0) {
      --y;
      StoppingY    -= TwoASquare;
      EllipseError += Ychange;
      Ychange      += TwoASquare;
    }
  }
}
//________________________________________________________________________________________________________________________________________

//sounds & music
//====================================================================================================
Mix_Chunk *sound_load( char *filename){
     if (fileExists(filename))      
          return Mix_LoadWAV(filename);
     else 
          return NULL;      
}
//________________________________________________________________________________________________________________________________________
void sound_play( Mix_Chunk *snd, int channel, int volume, int loop){
         Mix_Volume(channel,volume);        
         Mix_PlayChannel( channel, snd, loop);     
}
//________________________________________________________________________________________________________________________________________
void sound_destroy( Mix_Chunk *snd){
     if (snd!=NULL)
  		 Mix_FreeChunk(snd);
}
//________________________________________________________________________________________________________________________________________

void music_load( char *filename){
     if (fileExists(filename))           
          music = Mix_LoadMUS(filename);
     else 
          music= NULL;      
}
//________________________________________________________________________________________________________________________________________

void music_play( int volume, int loop){
     Mix_VolumeMusic(volume);
     switch(loop){
           case 0:
               	Mix_HaltMusic();
                break;
           case 1:
     		    Mix_PlayMusic( music, 1);
                break;
           
           case -1:
     		    Mix_PlayMusic( music, -1);
                break;
     }          
}

//________________________________________________________________________________________________________________________________________

//text
//====================================================================================================

void setfont( char *fontPath){
     _fontPath=let(fontPath);
}
//________________________________________________________________________________________________________________________________________

SDL_Surface *text(  char *string, int size, Uint32 col){
        SDL_Surface *txt;    
        TTF_Font *font;
        SDL_Color Col;
        
        Col.b=(col & 31) *8;
        Col.g=((col/32) & 31) *8;
        Col.r=((col/(64*32)) & 31)*8;
          
        font=TTF_OpenFont( _fontPath, size);    
        if (font!=NULL){
           txt= TTF_RenderText_Solid( font, string, Col);
       	   TTF_CloseFont(font);
           return txt;
        }
        else{               
             return NULL;   
        }
}
//________________________________________________________________________________________________________________________________________
